package jalview.ws2.gui;

import javax.swing.JMenu;

import jalview.gui.AlignFrame;

/**
 * Functional interface provided by {@link jalview.ws2.operations.Operation}
 * instances to construct the menu entry for the operations. The instances are
 * passed to the {@link jalview.gui.WebServicesMenuBuilder} and called during
 * menu construction.
 * 
 * @author mmwarowny
 */
@FunctionalInterface
public interface MenuEntryProviderI
{
  /**
   * Build menu entries directly under the given menu. This method is called by
   * {@link jalview.gui.WebServicesMenuBuilder} during menu construction.
   * 
   * @param parent
   *          parent menu
   * @param frame
   *          current alignFrame
   */
  public void buildMenu(JMenu parent, AlignFrame frame);
}
